#include(conditionMacros.inc)
[top]
components : WSN

[WSN]
type : cell
dim : (20,20,5)
delay : transport
defaultDelayTime : 10
border : nowrapped 
neighbors : WSN(-1,-1,0) WSN(-1,0,0) WSN(-1,1,0) 
neighbors : WSN(0,-1,0)  WSN(0,0,0)  WSN(0,1,0)
neighbors : WSN(1,-1,0)  WSN(1,0,0)  WSN(1,1,0)
neighbors : WSN(0,0,-1) WSN(0,0,2) WSN(0,0,3)
neighbors : WSN(1,1,1) WSN(-1,-1,1) WSN(0,0,1)
neighbors : WSN(-1,0,3) WSN(0,1,3)
initialvalue : 0
initialCellsValue : WSNEnergyMA.val
zone : TRBorderRule { (0,0,0)..(0,19,0) }
zone : TRBorderRule { (1,19,0)..(19,19,0) }
zone : LBorderRule { (1,0,0)..(18,0,0) }
zone : BBorderRule { (19,1,0)..(19,18,0) }
zone : cornerRule { (19,0,0) }
zone : energy { (0,0,1)..(19,19,1) }
zone : newPacket { (0,0,2)..(19,19,2) }
zone : blocked { (0,0,3)..(19,19,3) }
zone : rotation { (0,0,4)..(19,19,4) }
localtransition : WSN-rule


[WSN-rule]
rule : {0} 10 { (0,0,3)=1 }

rule : {(-1,1,0) +(0,0,2)} 10 {(-1,0,3)=1 and (0,1,3)=1}



rule : {(-1,0,0) + (0,1,0) +(0,0,2)} 10 {(1,1,1)>(0,0,1) and (-1,-1,1)>(0,0,1)}
rule : {(-1,0,0) + (0,0,2)} 10 {(1,1,1)<(0,0,1) and (-1,-1,1)>(0,0,1)}
rule : {(0,1,0) +(0,0,2)} 10 {(1,1,1)>(0,0,1) and (-1,-1,1)<(0,0,1)}
rule : {(0,0,2)} 10 {(1,1,1)<(0,0,1) and (-1,-1,1)<(0,0,1)}

rule : { 0.5*(0,1,0) +(0,0,2)} 10 {(1,1,1)=(0,0,1) and (-1,-1,1)>(0,0,1)}
rule : {(-1,0,0) + 0.5*(0,1,0) +(0,0,2)} 10 {(1,1,1)=(0,0,1) and (-1,-1,1)<(0,0,1)}
rule : {0.5*(-1,0,0) + (0,1,0) +(0,0,2)} 10 {(1,1,1)>(0,0,1) and (-1,-1,1)=(0,0,1)}
rule : {0.5*(-1,0,0)  +(0,0,2)} 10 {(1,1,1)<(0,0,1) and (-1,-1,1)=(0,0,1)}
rule : {0.5*(-1,0,0) + 0.5*(0,1,0) +(0,0,2)} 10 {(1,1,1)=(0,0,1) and (-1,-1,1)=(0,0,1)}
rule : { (0,0,2)} 10 { t } 
[TRBorderRule]
rule : 0 10 { t } 
[BBorderRule]



rule : {(-1,0,0)+(0,1,0)+(0,0,2)} 10 {(-1,-1,0)<0 } 

rule : {(-1,0,0) +(0,1,0) +(0,0,2)} 10 {(-1,-1,1)>(0,0,1)}
rule : { (0,1,0) +(0,0,2)} 10 {(-1,-1,1)<(0,0,1)}
rule : { 0.5*(-1,0,0) + (0,1,0) +(0,0,2)} 10 {(-1,-1,1)=(0,0,1)}

[LBorderRule]
rule : {(-1,0,0)+(0,1,0)+(0,0,2)} 10 {(1,1,0)<0   } 


rule : {(-1,0,0)  +(0,1,0) +(0,0,2)} 10 {(1,1,1)>(0,0,1) }
rule : {(-1,0,0) + (0,0,2)} 10 {(1,1,1)<(0,0,1) }
rule : {(-1,0,0) + 0.5* (0,1,0) +(0,0,2)} 10 {(1,1,1)=(0,0,1) }
[cornerRule]

rule : {(-1,0,0) + (0,1,0)} 10 { t}
[energy]
rule : {10000} 10 { (0,0,2)=1 }
rule : {(0,0,0)+(0,0,-1)} 10 { (0,0,-1) >= 0 } 
rule : {(0,0,0)} 10 {t } 
[newPacket]
rule : {1} 10 { (0,0,2)=1} 
rule : {0} 10 { t } 
[rotation]
rule : {0} 10 { (0,0,0)=1 } 
rule : {1} 10 { (0,0,0)=2 } 
rule : {2} 10 { (0,0,0)=3 } 
rule : {3} 10 { (0,0,0)=4 } 
rule : {4} 10 { (0,0,0)=5 } 
rule : {5} 10 { (0,0,0)=6 } 
rule : {6} 10 { (0,0,0)=7 } 
rule : {7} 10 { (0,0,0)=8 } 
rule : {8} 10 { (0,0,0)=9 } 
rule : {9} 10 { (0,0,0)=0 }  
[blocked]
rule : {1} 10 { (0,-1,0)=1 and (1,-1,0)=1 and (1,0,0)=1} 
rule : {(0,0,0)} 10 { t } 
